/* -*- Mode: C++; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   John Bandhauer <jband@netscape.com>
 *   Pierre Phaneuf <pp@ludusdesign.com>
 *	 Micromuse Ltd
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

/**	Code lifted from mozilla/xpfe/bootstrap and modified to:
	- Remove security contrains as ncisetup is only aimed to be a native application.
	- Relocated the storage of the user profile to a folder that do not conflict with mozilla itself.
	- Default to chrome ncisetup.jar
	- Allow a console mode that run like xpcshell and default to ncisetup.js

*/


#include "nsCOMPtr.h"
#include "nsString.h"
#include "nsIWindowCreator.h"
#include "nsIWindowCreator2.h"
#include "nsWeakReference.h"

#include "nsIEventQueue.h"


class CXULDlgApp : public nsIWindowCreator2,
                   public nsSupportsWeakReference
{

	public:

		CXULDlgApp();
		virtual ~CXULDlgApp();

		NS_DECL_ISUPPORTS
		NS_DECL_NSIWINDOWCREATOR
		NS_DECL_NSIWINDOWCREATOR2


		virtual nsresult Initialize( int argc, char* argv[], bool bDoGUI );
		virtual nsresult DoModal( const nsACString &url );
		virtual nsresult DoScript( const nsACString &url );
		virtual nsresult Terminate();

	private:
		nsresult InitializeWindowCreator();
		nsresult TerminateWindowCreator();

		nsIEventQueue* mEventQ ;


};
