

/***********************************************************************
 *
 *      Copyright (C) 2004 Micromuse Ltd.
 *      All Rights Reserved
 *
 *      THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE
 *      The copyright notice above does not evidence any
 *      actual or intended publication of such source code.
 *
 *      RESTRICTED RIGHTS:
 *
 *      This file may have been supplied under a license.
 *      It may be used, disclosed, and/or copied only as permitted
 *      under such license agreement.  Any copy must contain the
 *      above copyright notice and this restricted rights notice.
 *      Use, copying, and/or disclosure of the file is strictly
 *      prohibited unless otherwise provided in the license agreement.
 *
 ***********************************************************************/

var DoInstall = false;
var PackageManager ;
var PropMgr;
var CmdLine;
var FeatureList = new Array;
var ProductList = new Array;

var PropertiesPerPage = 4;
var errorCode = 0;

/*
 * Does what it says on the tin:)
 *
 */
function InitializePackage() {
	/// Having a package manager is important
	PackageManager = Components.classes["@micromuse.com/NCIPackageManager;1"].getService(Components.interfaces.nsINCIPackageManager);


	/// Get the Property Manager too
	PropMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);				


	/// Read the command line interface
	CmdLine = Components.classes["@mozilla.org/appshell/commandLineService;1"].getService(Components.interfaces.nsICmdLineService);
	var install = CmdLine.getCmdLineValue("-install");

	if ( install == null ) {
		install = CmdLine.getCmdLineValue("/install");
	}

	/// Check the options and present help just in case.
	if ( install == null ) {
		return false;
	} else {
		PackageManager.productXML = install;
	}
	return true;
}



/*
 * Don't assume PackageManager is global, provide an accessor
 */
function GetPackageManager() {
        return PackageManager;
}



/*
 * Title of main page
 */
function PrintTitle() {
	clearscreen();
	dump( "\nProduct: " + PackageManager.products.item(0).name + "\n\n");
}



/*
 * List normal options
 */
function ListOption( key, action ) {
	dump( "\t" + key + ") " + action + "\n" );
}

var ios;

/** Get a scriptable stream from the given uri, then
 read the stream an put the data into a string variable
*/
function readFromUri( uri ) {

	var channel = ios.newChannelFromURI(uri);

	var instream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	instream.init (channel.open());

	var txtout = "";
	var avail;

	while ((avail = instream.available()) > 0) {
		txtout += instream.read(avail);
	}
	return  txtout ;
}

function displayWelcomePage() {

	PrintTitle();

	if ( PackageManager.products.item(0).actionRequest == 1 ) {
		dump("\nWelcome to the Netcool text installer for " + PackageManager.products.item(0).name + "\n\n" );
	} else if ( PackageManager.products.item(0).actionRequest == 5 ) {
		dump("\nWelcome to the Netcool text maintenance installer.\n\nThis will help you to update your current installation of " + PackageManager.products.item(0).name + ".\n\n" );
	} else if ( PackageManager.products.item(0).actionRequest == 3 ) {
		dump("\nWelcome to the Netcool text installer to upgrade " + PackageManager.products.item(0).name + " version " + PackageManager.products.item(0).instVersion + " to " + PackageManager.products.item(0).name + " version " + PackageManager.products.item(0).version + ".\n\n" );
	}
	
	option = getuservalue( "\nTo continue press", "Enter" );
	option = option.toLowerCase();
	
	if ( option == "enter" ) {
		option = "y";
	} else {
		if ( option != "" ) {
			option = "q";
		} else {	
			option = "y" ;
		}
	}
	
	return option;
}

function displayLicenseAgreementPages() {


	var option = "";
	var k;
	ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uri = ios.newURI( PackageManager.products.item(0).licenseTextLocation , "", null);

	lText = readFromUri( uri );
	aText = lText.split("\n");

	var lastpage = 0;

	for ( i = 0 ; i < aText.length ; ) {
	
		lastpage = i;

		clearscreen();
		dump("End User License Agreement for " + PackageManager.products.item(0).name + "\n\n" );
		for ( j=0; i < aText.length && j < 20 ; i++ , j++ ) {		
			dump( aText[i] + "\n" );
		}
		if ( i < aText.length ) {
			option = getuservalue( "\nDo you agree to be bound by the terms of this license (Yes/No)", "" );
			option = option.toLowerCase();
		}
		if ( option == "y" ) {
			break;
		}
		if ( option == "n" ) {
			break;
		}		

		if ( option == "yes" ) {
			option = "y";
			break;
		}
		if ( option == "no" ) {
			option = "n";
			break;
		}
	}
	
	while( option != "y" && option != "n"  ) {
		option = getuservalue( "\nDo you agree to be bound by the terms of this license (Yes/No)", "" );
		option = option.toLowerCase().charAt(0);
	}
	
	return option;
}

/**	ask for a new value, then set it in the property manager
*/
function getPropFromUser( prop )
{
	newVal = getuservalue( "\n" + prop.description , "" + prop.value );
	
	var pattern = new RegExp( prop.regexp );

	if ( pattern.test(newVal)) {
		prop.value = newVal;
		return "";
	} else {
		return "[" + newVal + "] is an invalid value. Must match " + prop.regexp + ".";		
	}
}

function getPropsFromUserPage( startPage ) {
	var error = "";
	var visibleprops = new Array();
	var j=0;
	var i=0;
	for ( i=0 ; i < PackageManager.products.item(0).props.length ; i++ ){
		var prop = PackageManager.products.item(0).props.item(i);
		if ( prop.visible ) {
			visibleprops[j] = prop;
			j++;
		}		
	}
	
	do {
		PrintTitle();

		lastIndex = visibleprops.length;
		startIndex = (startPage-1) * PropertiesPerPage ;

		if ((startPage * PropertiesPerPage ) < lastIndex ) {
			lastIndex = startIndex + PropertiesPerPage 
		}

		dump( "Select\tProperties\n" );
		dump( "------\t----------\n" );

		for ( i=startIndex ; i < lastIndex ; i++ ) {
			var prop = visibleprops[i];
			var name = prop.name;
			var description = prop.description;
			var value = prop.value;

			dump( " " + ((i-startIndex)+1) + "\t" + description + "\n");
			dump( "\t[" + value + "]\n");	
		}
		dump( "\nSelect:\n" );
		ListOption( "1-" + ( lastIndex - startIndex ) , "Change Property" );
		ListOption( "i", "Install product" );
		ListOption( "p", "Previous page" );
		if ( lastIndex < visibleprops.length ) {
			ListOption( "n", "Next page" );
		}
		ListOption( "q", "Quit" );
		dump("\n" + error + "\n");

		option = getuservalue( "Option", "i" );

		switch(option) {
			case "n":		
			case "N":		
				if ( lastIndex >= visibleprops.length ) {
					option = "";
				} 
				break;
				
			case "q":		
			case "Q":		
			case "i":		
			case "I":		
			case "p":		
			case "P":		
				break;
				
			default:
				var num = option - 1 + startIndex ;
				if ( num >= 0 && num < visibleprops.length ) {
					error = getPropFromUser( visibleprops[num] );
				} else {
					error = "";
					// Error, invalid selection!
				}
				break;
		}
	} while( option != "i" && option != "q" && option != "n" && option != "p" );	
	
	return option;	
}


/********************** Features Selection ************************/

/**
 * Dump to the screen the currently available features
 */
function ListFeatures( ) {
	var pm = GetPackageManager();
	var i;
	var features = FeatureList;

	dump( "Select\tFeature\n" );
	dump( "------\t-------\n" );
	for( i=0; i< features.length; i++ ) {
		if ( features[i].action == "install" ) {
			dump( " [I]\t" );
		} else {
			dump( " [ ]\t" );
		}

		var parent = features[i].parent;
		while(parent) {
			if (parent.visible) {
				dump( "\t" );
			}
			parent = parent.parent;
		}
		dump( (i+1) );
		dump( ") " + features[i].name );
		dump( " - " + features[i].description );
		dump( "\n" );
	}
}

/*
 * Load the list of features
 */
function LoadFeatures( features ) {
	var i;

	for( i = 0; i<features.length; i++ ) {
		var feature = features.item(i);
		if ( feature.visible ) {
			FeatureList.push(feature);
		}
		if ( feature.features.length > 0 ) {
			LoadFeatures(feature.features);
		}
	}
}

/*
 * Feature select/deselection/toggling
 */
function SelectFeature( feature ) {
	feature.action = "install";
	if ( feature.parent ) {
		SelectFeature( feature.parent );
	}
}

function UnselectFeature( feature ) {
	var i;

	for( i=0; i<feature.features.length; i++ ) {
		UnselectFeature(feature.features.item(i));
	}
	feature.action = "";
}

function ToggleFeature( feature ) {
	if ( feature.action == "install" ) {
		UnselectFeature(feature);
	} else {
		SelectFeature(feature);
	}
}

/** display the features selection. Return 'i' for install, or 'q' for quit
*/
function displayFeatureSelection() {

	PackageManager.PrepareWizard();	// to update the properties to load
	var option = "";
	var action = "";
	do {
		action = "";
		PrintTitle();
		ListFeatures();
		PackageManager.PrepareWizard();	// to update the properties to load

		if ( option=="e1" ) {
			dump("Error: The current feature selection does not install any packages. Please check your product description or feature selection.\n");
		}

		dump( "\n\nSelect:\n" );
		ListOption( "1-" + FeatureList.length, "Toggle feature" );
		ListOption( "s", "Select all features" );
		ListOption( "u", "Unselect all features" );
		ListOption( "i", "Install selected features" );
		
		if ( PackageManager.products.item(0).props.length > 0 ) {
			ListOption( "n", "Next page (properties configuration)" );
		}
		ListOption( "q", "Quit" );

		option = getuservalue( "Option", "i" );

		switch(option) {
	
			case "n":
			case "N":
			case "i":
			case "I":
			
				/// Find a way of updating features....
				PackageManager.PrepareWizard();
				if ( PackageManager.products.item(0).packages.length == 0 ) {
					option="e1";
				} break;

			case "s":
			case "S":
				action = "install";
				// Fall through ...
			case "u":
			case "U":
				// Apply apply to all features
				var i;
				for( i = 0; i<FeatureList.length; i++ ) {
					FeatureList[i].action = action;
				}
				break;

			case "q":
			case "Q":
				// Quit installation
				break;
			default:
				// A number? Try toggling a feature based on it
				var num = option - 1;
				if ( num >= 0 && num < FeatureList.length ) {
					ToggleFeature(FeatureList[num]);
				} else {
					// Error, invalid selection!
				}
				break;
			
		}
	} while( option != "i" && option != "q" && option != "n");
	
	return option;
}



/* List the selected features
*/
function ListInstallFeatures() {

	dump( "installing Features\n" );
	dump( "-------------------\n" );

	var pm = GetPackageManager();
	var i;
	var features = FeatureList;

	for( i=0; i< features.length; i++ ) {
		if ( features[i].action == "install" ) {
			dump( " [I]\t" );
		}

		var parent = features[i].parent;
		while(parent) {
			if (parent.visible) {
				dump( "\t" );
			}
			parent = parent.parent;
		}
		dump( (i+1) );
		dump( ") " + features[i].name );
		dump( " - " + features[i].description );
		dump( "\n" );
	}
	
	return true;
}



/* List the packages
*/
function ListInstallPackages( startPage ) {

	dump( "installing Packages\n" );
	dump( "-------------------\n" );
	
	var product = GetPackageManager().products.item(0);	
	if ( product.packages ) {
		for (i=0 ; i < product.packages.length ; i++ ) {
		
			if ( product.packages.item(i).actionRequest > 0 ) {
					
				var bCheck = true;
				dump( product.packages.item(i).name + " (V" + product.packages.item(i).version +")" );
					
						
				// Check the installed Status...
				if ( product.packages.item(i).actionRequest == 2 ) {
					dump( " - Obsolete.\n" );
				} else if ( product.packages.item(i).actionRequest == 1 ) {
					bCheck = product.packages.item(i).PreInstallCheck();
					dump(" - New install.\n");
				} else if ( product.packages.item(i).actionRequest == 3 ) {
					bCheck = product.packages.item(i).PreInstallCheck();
					dump(" - Upgrade.\n") ;
				} else if ( product.packages.item(i).actionRequest == 5 ) {
					bCheck = product.packages.item(i).PreInstallCheck();
					dump(" - Refresh.\n") ;
				}
				
				if ( !bCheck ) {							
					dump( "Pre-installation checks failed! Please check log files for more information.\n" );
					bOverallPreChecks = false;
					return false;
				}
			}			
		}
	}
	return true;
}


/* Display the install summary that are going 
	to be removed 
*/
function DisplayInstallSummary() {
	var option;
	option=" ";
	
	clearscreen();
	
	ListInstallFeatures();
	
	while( option != "i" && option != "m" && option != "c"  ) {
		option = getuservalue( "\nDo you want to continue ([I]nstall/[M]ore/[C]ancel)", "" );
		option = option.toLowerCase().charAt(0);		
	}
	
	if ( option=="m" ) {
		clearscreen();
	
		if ( ListInstallPackages(0) ) {
			dump("\n");

			while( option != "y" && option != "n"  ) {
				option = getuservalue( "\nDo you want to continue with install (Yes/No)", "" );
				option = option.toLowerCase().charAt(0);
			}

			if ( option == "y" || option=="yes" ) {
				return true;
			}

			return false;
		}
	} else if ( option=="i" ) {
		return true ; // install case...
	}
	
	return false;
}



/******************************* CORE INSTALLER ***************************/

/**
	Core Text wizard installer ...........
*/
function RunInstallWizard() {

	DoInstall = true;
	var option = "";

	/// check if we need to do more...
	params = CmdLine.getCmdLineValue("-params");
	if ( params != "" ) {
		PackageManager.paramXML = params ;	
	}

	/// Load the product
	PackageManager.Initialize();	
	PackageManager.products.item(0).actionRequest = 1;
	
	if ( PackageManager.products.item(0).actionRequest == 6 ) {
		PrintTitle();
		dump("Error: An updated version of " + PackageManager.products.item(0).name + " is already installed.\n");
		dump("       Downgrade is not allowed\n\n");
		errorCode=2;
	} else {
	
		option = displayWelcomePage();
		
		if ( option == "y" ) {
		
			option = displayLicenseAgreementPages();
			
			if ( option == "y" ) {
		
				LoadFeatures(PackageManager.products.item(0).features);

				var currentPage = 0;

				var option = "";
				do {
					var action = "";

					if ( currentPage==0 ) {
						option = displayFeatureSelection();
					} else if ( currentPage ) {
						option = getPropsFromUserPage( currentPage );
					}

					if ( option == "n" ) {
						currentPage+=1;
					} else if ( option == "p" ) {
						currentPage-=1;
					}

				} while( option != "i" && option != "q" );


				if (option == "i" ) {
					var bPreInstallCheck = true;
				
					/* Check the pre install action */
					for (i=0 ; i < PackageManager.products.item(0).packages.length ; i++ ) {
						if ( PackageManager.products.item(0).packages.item(i).actionRequest == 1 || PackageManager.products.item(0).packages.item(i).actionRequest == 3 || PackageManager.products.item(0).packages.item(i).actionRequest == 5  ) {
							if (!PackageManager.products.item(0).packages.item(i).PreInstallCheck() ) {
								dump( "\nPackage" + PackageManager.products.item(0).packages.item(i).name + ": Precheck failed.\n");
								bPreInstallCheck = false;
							}
						}
					}
					
					if ( bPreInstallCheck ) {	
						if ( DisplayInstallSummary() ) {					
							dump( "\nInstalling product: " + PackageManager.products.item(0).name + ".\n");
							PropMgr.Commit();
							PackageManager.products.item(0).Install( null );
							dump( "\nProduct " + PackageManager.products.item(0).name + " installed OK.\n");
						}
					} else {
						dump( "\nProduct " + PackageManager.products.item(0).name + " not installed: Precheck failed.\n");
						errorCode =2;
					}
				}
			}
		}
	}
	return errorCode;
}

function LoadProducts( products ) {

	var i;

	for( i = 0; i<products.length; i++ ) {
		var product = products.item(i);
		ProductList.push(product);
	}
}

function ToggleProduct( prd ) {
	if ( prd.remove ) {
		prd.remove = false;
	} else {
		prd.remove = true;
	}
}


function ListProducts() {

	var i;
	var products = ProductList;

	dump( "Select\tProduct\n" );
	dump( "------\t-------\n" );
	for( i=0; i< products.length; i++ ) {
		if ( products[i].remove ) {
			dump( " [R]\t" );
		} else {
			dump( " [ ]\t" );
		}
		dump( "(" + (i+1) + ") " + products[i].name );
		dump( "\n" );
	}
}

function ListOptionsForRemove() {
	dump( "\n\nSelect:\n" );
	ListOption( "1-" + ProductList.length, "Toggle product" );
	ListOption( "r", "Remove selected products" );
	ListOption( "q", "Quit" );
}


/* List the packages
*/
function ListRemovePackages( startPage ) {

	dump( "Removing Packages\n" );
	dump( "-----------------\n" );
	
	packages = GetPackageManager().readyToRemovePackages;			
	if ( packages ) {
		for (i=0 ; i < packages.length ; i++ ) {
			dump( packages.item(i).name + " (V" + packages.item(i).version +")\n" );
		}
	}
	return true;
}

/* List the products
*/
function ListRemoveProducts( startPage ) {

	dump( "Removing Products\n" );
	dump( "-----------------\n" );

	if ( GetPackageManager().products ) {
		for (i=0 ; i < GetPackageManager().products.length ; i++ ) {
			product = GetPackageManager().products.item(i);
			if ( product.remove ) {
				dump( product.name + " (V" + product.version + ")\n" );
			}
		}
	}	
	return true;
}

/* Display the remove summary that are going 
	to be removed 
*/
function DisplayRemoveSummary() {
	var option;
	option=" ";
	
	clearscreen();
	
	ListRemoveProducts(0);
	dump("\n");
	ListRemovePackages(0)
	dump("\n");

	while( option != "y" && option != "n"  ) {
		option = getuservalue( "\nDo you want to continue (Yes/No)", "" );
		option = option.toLowerCase().charAt(0);
	}
	
	if ( option == "y" || option=="yes" ) {
		return true;
	}

	return false;
}


function CheckRemoveCount() {

	var removeCount=0;
	GetPackageManager().PrepareReadyToRemovePackages();
	if ( GetPackageManager().products ) {
		for (i=0 ; i < GetPackageManager().products.length ; i++ ) {
			if ( GetPackageManager().products.item(i).remove ) {
				removeCount++;
			}
		}
	}
	return removeCount;
}


function RunRemoveWizard() {

	PackageManager.Initialize();
	
	DoRemove =false;

	if ( PackageManager.products && PackageManager.products.length > 0 ) {

		/// Find a way of updating features....
		LoadProducts( PackageManager.products );

		var option = "";
		do {
			var action = "";

			clearscreen();
			ListProducts();
			ListOptionsForRemove();
			
			if (option=="e1" ) {
				dump("ERROR: There is no products to remove. Please select a product.\n");
			}

			option = getuservalue( "Option", "r" );

			switch(option) {
				case "r":
				case "R":
				
					if ( CheckRemoveCount() > 0 ) {				
						DoRemove = true;
					} else {						
						option="e1";
					}
					break;

				case "q":
				case "Q":
					break;

				default:
					// A number? Try toggling a feature based on it
					var num = option - 1;
					if ( num >= 0 && num < ProductList.length ) {
						ToggleProduct(ProductList[num]);
					} else {
						// Error, invalid selection!
					}
				break;
			}

		} while( option != "r" && option != "q" );

		if ( DoRemove ) {			
			
			
			if ( DisplayRemoveSummary() ) {
				dump("Removing packages, please wait...\n");
				PackageManager.Remove( null );
				dump("Selected packages removed OK.\n");
				dump("Selected products removed OK.\n");
			}
		}	
	} else {
		dump("There are no products or packages to remove.\n");
	}
}


/*
 * Main code
 */
try {
	DoInstall = InitializePackage();


	/// Get the error level requisted
	gLog = Components.classes["@micromuse.com/NCILog;1"].getService(Components.interfaces.nsINCILog);
	var errorlevel = CmdLine.getCmdLineValue("-errorlevel");
	if ( errorlevel == "debug" ) {
		gLog.level=3;
	} else if ( errorlevel == "warning" ) {
		gLog.level=1;
	} else if ( errorlevel == "info" ) {
		gLog.level=2;
	} else if ( errorlevel == "error" ) {
		gLog.level=0;
	} else {
		gLog.level=gLog.level;
	}

	if ( DoInstall ) {
		RunInstallWizard();
	} else {	
		RunRemoveWizard();	
	}

	var propMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);
	Win32Reb = propMgr.Get( "REBOOT_REQUIRED" );
	if ( Win32Reb == "1" ) {
		dump("A reboot is required to complete this operation.\n");
		errorCode = 1;
	}
}

catch ( e ) {

	var pStrBdle= Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var errBundle = pStrBdle.createBundle("chrome://ncisetup/locale/errorCode.properties");
	
	dump("\nError\n");
	var errorText=""

	/// Our error code are in the range [2153185280 + error code]
	if ( e.result > 2153185280 ) {
		try {
			errorText = errBundle.GetStringFromName( ( e.result - 2153185280 ));
		}
		catch ( e ) {
			errorText = "Error code: " + e.result + ". Please check ncisetup.log.\n\n" ;
		}
	}
	
	errorText = errorText + "\nPlease check ncisetup.log.\n" ;
	dump( errorText );
	errorCode = 2;
}

finally {
	PackageManager.Finalize();
	PackageManager = null;
}

quit(errorCode);



