/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Mozilla Communicator client code,
 * released March 31, 1998.
 *
 * The Initial Developer of the Original Code is Netscape Communications
 * Corporation.  Portions created by Netscape are
 * Copyright (C) 2000 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *     Conrad Carlen <conrad@ingress.com>
 *     Micromuse Ltd
 */

/**	Code lifted from mozilla/xpfe/bootstrap and modified to:
	- Remove security contrains as ncisetup is only aimed to be a native application.
	- Relocated the storage of the user profile to a folder that do not conflict with mozilla itself.
	- Default to chrome ncisetup.jar
	- Allow a console mode that run like xpcshell and default to ncisetup.js

*/

#include "nsIDirectoryService.h"
#include "nsILocalFile.h"
#include "nsString.h"

class nsIFile;

//*****************************************************************************
// class nsAppFileLocationProvider
//*****************************************************************************

class nsCustomAppFileLocationProvider : public nsIDirectoryServiceProvider2
{
public:
	nsCustomAppFileLocationProvider();
	nsCustomAppFileLocationProvider( const nsACString& aProductDirName );

   NS_DECL_ISUPPORTS
   NS_DECL_NSIDIRECTORYSERVICEPROVIDER
   NS_DECL_NSIDIRECTORYSERVICEPROVIDER2

protected:
   virtual              ~nsCustomAppFileLocationProvider();

   NS_METHOD            CloneMozBinDirectory(nsILocalFile **aLocalFile);
   NS_METHOD            GetProductDirectory(nsILocalFile **aLocalFile);
   NS_METHOD            GetDefaultUserProfileRoot(nsILocalFile **aLocalFile);

   nsCString              mProductDirName;
   nsCOMPtr<nsILocalFile> mMozBinDirectory;
};


nsresult GRE_CustomStartup( const nsACString& aProductDirName );
nsresult GRE_CustomShutdown();
